package com.ruoyi.user.service;

import com.ruoyi.clock.domain.Employee;
import com.ruoyi.clock.domain.vo.EmployeeVo;
import com.ruoyi.user.domain.User;
import com.ruoyi.user.domain.vo.UserVo;
import com.ruoyi.user.domain.bo.UserBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.weixin.domain.WxEmployeeDto;
import com.ruoyi.weixin.domain.WxUserDto;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 小程序用户管理Service接口
 *
 * @author wuchao
 * @date 2022-03-03
 */
public interface IUserService {

    /**
     * 查询小程序用户管理
     *
     * @param id 小程序用户管理主键
     * @return 小程序用户管理
     */
    UserVo queryById(Long id);

    /**
     * 查询小程序用户管理列表
     *
     * @param user 小程序用户管理
     * @return 小程序用户管理集合
     */
    TableDataInfo<UserVo> queryPageList(UserBo bo, PageQuery pageQuery);

    /**
     * 查询小程序用户管理列表
     *
     * @param user 小程序用户管理
     * @return 小程序用户管理集合
     */
    List<UserVo> queryList(UserBo bo);

    /**
     * 修改小程序用户管理
     *
     * @param user 小程序用户管理
     * @return 结果
     */
    Boolean insertByBo(UserBo bo);

    /**
     * 修改小程序用户管理
     *
     * @param user 小程序用户管理
     * @return 结果
     */
    Boolean updateByBo(UserBo bo);

    /**
     * 校验并批量删除小程序用户管理信息
     *
     * @param ids     需要删除的小程序用户管理主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    User authorization(WxUserDto wxUserDto);

    User getById(Long userId, boolean isThrow);

    Employee login(WxEmployeeDto wxEmployeeDto);

}
